<?php

function getConsumer()
{
	$sendmsgConsumer = get_option('sendmsg_api_opts');
	if (isset($sendmsgConsumer) && !empty($sendmsgConsumer['user_id']))
		$sendmsgConsumer = new SendmsgConsumer($sendmsgConsumer['user_id'], $sendmsgConsumer['api_key']);
	else
		$sendmsgConsumer = null;
	return $sendmsgConsumer;
}

//start of function sendmsg_opts_do_page
function sendmsg_opts_do_page()
{
	if (isset($_GET['settings-updated'])) { ?>
		<div id="message" class="updated">
			<p><strong><?php _e('Settings saved.') ?>
				</strong></p>
		</div>
	<?php } ?>

	<div class="wrap">
		<h2>הגדרות תוסף שלח מסר</h2>
		<h3>פרטי משתמש שלח מסר</h3>

		<form method="post" id="api_details_form" action="options.php">
			<?php settings_fields('sendmsg_opts');
			$options = get_option('sendmsg_api_opts'); ?>
			<table class="form-table">
				<tr valign="top">
					<th scope="row">user_id</th>
					<td><input type="text" name="sendmsg_api_opts[user_id]" value="<?php echo $options['user_id']; ?>" />
					</td>
				</tr>
				<tr valign="top">
					<th scope="row">API Key</th>
					<td><input type="text" name="sendmsg_api_opts[api_key]" value="<?php echo $options['api_key']; ?>" />
					</td>
				</tr>
			</table>
			<p class="submit">
				<input type="submit" class="button-primary" value="עדכן קבוצות דיוור" />
			</p>
			<?php echo (getConsumer() == null ? '<p>הערה: לקבלת הפרטים יש להתקשר למוקד התמיכה של שלח מסר 077-4600600</p>' : '') ?>
		</form>


		<?php

		////
		//	$function_slug = 'user_register';
		//	require __DIR__.'/includes/chunks/admin-lists-fields.php';


		if (isset($options) && !empty($options['user_id'])) {
		?>
			<h3>שליחת פרטי נרשמים חדשים לאתר או עדכון קיימים</h3>
			<form method="post" action="options.php">
				<?php settings_fields('sendmsg_opts'); ?>
				<input type="hidden" name="sendmsg_api_opts[user_id]" value="<?php echo $options['user_id']; ?>" />
				<input type="hidden" name="sendmsg_api_opts[api_key]" value="<?php echo $options['api_key']; ?>" />
				<?php


				$lists = getConsumer()->sendmsg_get_lists();
				update_option('sendmsg_lists', $lists);

				update_option('sendmsg_fields_keys', getConsumer()->sendmsg_get_fields_keys());
				render_lists_and_transform_admin('user_register');
				add_new_list_Script();


				?>

				<p class="submit">
					<input type="submit" class="button-primary" value="<?php echo _e('Save Changes'); ?>" />
				</p>
			</form>

		<?php
		}
		?>
	</div>
<?php
}
//end of function sendmsg_opts_do_page









//start function render_lists_and_transform_admin
function render_lists_and_transform_admin($function_slug)
{

	$source_fields = array(
		'user_register' => array(
			array('name' => 'user_login', 'display' => 'שם משתמש', 'visible' => True),
			array('name' => 'display_name', 'display' => 'השם שיוצג בפומבי', 'visible' => True),
			array('name' => 'user_nicename', 'display' => 'כינוי'),
			array('name' => 'first_name', 'display' => 'שם פרטי'),
			array('name' => 'last_name', 'display' => 'שם משפחה'),
			array('name' => 'description', 'display' => 'תיאור'),
		),
		'woocommerce' => array(
			array('name' => 'billing.address_1', 'display' => 'כתובת 1'),
			array('name' => 'billing.address_2', 'display' => 'כתובת 2'),
			array('name' => 'billing.city', 'display' => 'עיר'),
			array('name' => 'billing.postcode', 'display' => 'מיקוד'),
			array('name' => 'billing.phone', 'display' => 'טלפון'),
			array('name' => 'date_created.date', 'display' => 'תאריך רכישה'),
			//	array('name'=>'customer_note','display'=>'הערת לקוח'),	
		),
		'user_register_ap_id' => array(
			array('name' => 'ap_id', 'display' => 'מזהה שותף'),
		),
		'woocommerce_ap_id' => array(
			array('name' => 'ap_id', 'display' => 'מזהה שותף'),
		),
	);
?>
	<h4>קבוצת דיוור</h4>
	<p>ניתן לבצע בחירה מרובה באמצעות צירוף מקש Ctrl</p>

	<select id="<?php echo $function_slug ?>" class="groups-list" name="sendmsg_<?php echo $function_slug; ?>_defaults_lists[]" multiple>
		<?php
		$lists = getConsumer()->sendmsg_get_lists();
		update_option('sendmsg_lists', $lists);
		$lists = get_option('sendmsg_lists');
		$selected_lists_ids = get_option("sendmsg_{$function_slug}_defaults_lists", '0');

		foreach ($lists as $item) {

			$opOutput = "<option value='%d' %s>%s</option>";
			echo wp_sprintf($opOutput, $item['id'], is_array($selected_lists_ids) && ((in_array($item['id'], $selected_lists_ids)) ? ' selected' : ''), $item['name']);
		}
		?>


	</select>
	<p>קבוצת דיוור חדשה</p>
	<input class="create_new_list_textfield" id="<?php echo $function_slug; ?>" type="text" />
	<input id="<?php echo $function_slug ?>" class="create_new_list_button" type="button" value="צור" />
	<span class="creating_list_label" id="<?php echo $function_slug; ?>" style="visibility:hidden">יוצר רשימה...</span>
	<h4>שדות שיישלחו מהאתר והתאמה לשדות במערכת שלח-מסר</h4>
	<table class="form-table">
		<tbody>

			<?php
			update_option('sendmsg_fields_keys', getConsumer()->sendmsg_get_fields_keys());
			$keys = get_option('sendmsg_fields_keys');
			$transform_array = get_option("sendmsg_{$function_slug}_transform_matrix_raw");

			for ($i = 0; $i < sizeof($source_fields[$function_slug]); $i++) { ?>
				<tr valign="top">
					<td>

						<label><?php echo $source_fields[$function_slug][$i]['display'] ?></label><input name="sendmsg_<?php echo $function_slug ?>_transform_matrix_raw[<?php echo $i ?>][0]" type="hidden" value="<?php echo $source_fields[$function_slug][$i]['name'] ?>" />

					</td>
					<td>
						<select class="unique-by-group-keys" name="sendmsg_<?php echo $function_slug; ?>_transform_matrix_raw[<?php echo $i ?>][1]">
							<option value="" selected>ללא הצלבה</option>
							<?php

							foreach ($keys as $k) {
								$dom = new DOMDocument;
								$optionTag = $dom->createElement('option', $k);

								$valueTag = $dom->createAttribute('value');
								$valueTag->value = $k;

								if ($transform_array && !empty($transform_array[$i]) && $transform_array[$i]['1'] == $k) {

									$SelectedAtt = $dom->createAttribute('selected');
									$optionTag->appendChild($SelectedAtt);
								}

								$optionTag->appendChild($valueTag);
								$dom->appendChild($optionTag);

								echo $dom->saveHTML();
							}
							?>

						</select>
					</td>
				</tr>
			<?php } ?>
		</tbody>
	</table>
	<?php
}
//end function render_lists_and_transform_admin


//woocommerce

add_filter('woocommerce_product_data_tabs', 'add_sendmsg_product_data_tab');
function add_sendmsg_product_data_tab($product_data_tabs)
{
	$product_data_tabs['sendmsg-tab'] = array(
		'label' => __('שלח מסר', 'sendmsg_text_domain'),
		'target' => 'sendmsg_product_data',
	);
	return $product_data_tabs;
}

// Next provide the corresponding tab content by hooking into the 'woocommerce_product_data_panels' action hook
// See https://github.com/woothemes/woocommerce/blob/master/includes/admin/meta-boxes/class-wc-meta-box-product-data.php
// for more examples of tab content
// See https://github.com/woothemes/woocommerce/blob/master/includes/admin/wc-meta-box-functions.php for other built-in
// functions you can call to output text boxes, select boxes, etc.

add_action('woocommerce_product_data_panels', 'add_sendmsg_product_data_fields');
//start function add_sendmsg_product_data_fields
function add_sendmsg_product_data_fields()
{
	if (getConsumer() == null) {
	?>
		<div id="sendmsg_product_data" class="panel woocommerce_options_panel">
			<p> יש לאקטב את תוסף שלח מסר באמצעות מספר האתר וסיסמת ה-api</p>
			<div style="display: flex;">
				<p style="margin: 0;padding: 0px 9px 0px 1%;line-height: 30px;"> להגדרת הפרטים לחץ על הכפתור</p>
				<a href="admin.php?page=sendmsg_opts" class="button-primary" style="max-height: 30px;display: flex;">הגדרת הפרטים</a>
			</div>
		</div>
	<?php
		exit();
	}


	global $woocommerce, $post;


	?>
	<!-- id below must match target registered in above add_sendmsg_product_data_tab function -->
	<div id="sendmsg_product_data" class="panel woocommerce_options_panel">
		<?php
		$lists = getConsumer()->sendmsg_get_lists();
		update_option('sendmsg_lists', $lists);
		$lists = get_option('sendmsg_lists');
		$new_list = array();
		foreach ($lists as $l) {
			$new_list[$l['id']] = $l['name'];
		}
		$post_id = get_the_ID();
		?>

		<p class="form-field sendmsg_select_lists_field "><label for="sendmsg_select_lists">קבוצות דיוור</label><select id="sendmsg_select_lists" name="sendmsg_select_lists[]" class="select short" multiple="multiple">
				<?php
				$lists = getConsumer()->sendmsg_get_lists();
				update_option('sendmsg_lists', $lists);
				$lists = get_option('sendmsg_lists');

				$selected_lists_ids = get_post_meta($post_id, 'sendmsg_woocommerce_item_defaults_lists', true);

				if (!isset($selected_lists_ids)) $selected_lists_ids = array('0');




				foreach ($lists as $k) {
					$dom = new DOMDocument;
					$optionTag = $dom->createElement('option', $k['name']);

					$valueTag = $dom->createAttribute('value');
					$valueTag->value = esc_attr($k['id']);
					if (in_array($l['id'], $selected_lists_ids)) {

						$SelectedAtt = $dom->createAttribute('selected');
						$optionTag->appendChild($SelectedAtt);
					}

					$optionTag->appendChild($valueTag);
					$dom->appendChild($optionTag);

					echo $dom->saveHTML();
				}
				?>

			</select> <span class=" description">בחר קבוצת דיוור למשלוח פרטי ההזמנה</span></p>



		<p>קבוצת דיוור חדשה</p><input class="create_new_list_textfield" id="sendmsg_woommerce_item" type="text" /><input id="sendmsg_woommerce_item" class="create_new_list_button" type="button" value="צור" /><span class="creating_list_label" id="sendmsg_woommerce_item" style="visibility:hidden">יוצר רשימה...</span>

		<h4>שדות שיישלחו מהאתר והתאמה לשדות במערכת שלח-מסר</h4>
		<?php
		$transform_array = get_post_meta($post_id, 'transform_matrix_raw', true);
		$source_item_fields = array(
			array('name' => 'sku', 'display' => 'מק"ט', 'visible' => True),
			array('name' => 'name', 'display' => 'שם המוצר', 'visible' => True),
			array('name' => 'sale_price', 'display' => 'מחיר'),
			array('name' => '_order.coupon_lines', 'display' => 'קופון'),
			array('name' => '_order.customer_note', 'display' => 'הערת רכישה'),
		);
		?>
		<table class="form-table">
			<tbody>
				<?php
				$keys = get_option('sendmsg_fields_keys');
				for ($i = 0; $i < sizeof($source_item_fields); $i++) { ?>
					<tr valign="top">
						<td>&nbsp</td>
						<td>
							<label style="text-align:left"><?php echo $source_item_fields[$i]['display'] ?></label>
							<input type="hidden" name="transform_matrix_raw[<?php echo $i; ?>][0]" value=<?php echo $source_item_fields[$i]['name']; ?>>
						</td>
						<td>

							<select class="unique-by-group-keys ajax_chosen_select_products" name="transform_matrix_raw[<?php echo $i ?>][1]">
								<option value="" selected>ללא הצלבה</option>
								<?php

								foreach ($keys as $k) {
									$dom = new DOMDocument;
									$optionTag = $dom->createElement('option', $k);

									$valueTag = $dom->createAttribute('value');
									$valueTag->value = $k;

									if (!empty($transform_array) && !empty($transform_array[$i]) && $transform_array[$i]['1'] == $k) {

										$SelectedAtt = $dom->createAttribute('selected');
										$optionTag->appendChild($SelectedAtt);
									}

									$optionTag->appendChild($valueTag);
									$dom->appendChild($optionTag);

									echo $dom->saveHTML();
								}
								?>
							</select>

						</td>
					</tr>
				<?php } ?>
			</tbody>
		</table>
	</div>
	<?php
	add_new_list_Script();
}
//end function add_sendmsg_product_data_fields


add_action('woocommerce_process_product_meta', 'woocommerce_add_custom_product_fields_save');
function woocommerce_add_custom_product_fields_save($post_id)
{
	// Select
	$lists = $_POST['sendmsg_select_lists'];
	if (!empty($lists))
		update_post_meta($post_id, 'sendmsg_woocommerce_item_defaults_lists', $lists);

	$matrix = $_POST['transform_matrix_raw'];
	if (!empty($matrix))
		update_post_meta($post_id, 'transform_matrix_raw', $matrix);
}

add_action('wp_ajax_create_new_list', 'create_new_list');
function create_new_list()
{
	$list_name = $_POST['list_name'];
	if (!empty($list_name)) getConsumer()->sendmsg_create_new_list($list_name);
	wp_die(); // this is required to terminate immediately and return a proper response
}

add_action('wp_ajax_get_lists', 'get_lists');
function get_lists()
{
	$response = getConsumer()->sendmsg_get_lists();
	wp_send_json($response);
}

add_action('admin_init', 'sendmsg_opts_init');
function sendmsg_opts_init()
{
	register_setting('sendmsg_opts', 'sendmsg_api_opts', 'sendmsg_api_opts_validate');
	register_setting('sendmsg_ap_opts', 'sendmsg_ap_opts', 'sendmsg_ap_validate');
	register_setting('sendmsg_opts', 'sendmsg_user_register_transform_matrix_raw');
	register_setting('sendmsg_ap_opts', 'sendmsg_user_register_ap_id_transform_matrix_raw');
	register_setting('sendmsg_opts', 'sendmsg_user_register_defaults_lists', 'sendmsg_user_register_defaults_lists_validate');
	register_setting('sendmsg_ap_opts', 'sendmsg_user_register_ap_id_defaults_lists');
	register_setting('sendmsg_woocommerce_opts', 'sendmsg_woocommerce_defaults_lists', 'sendmsg_woocommerce_defaults_lists_validate');
	register_setting('sendmsg_woocommerce_opts', 'sendmsg_woocommerce_transform_matrix_raw');
	register_setting('sendmsg_ap_opts', 'sendmsg_woocommerce_ap_id_defaults_lists', 'sendmsg_woocommerce_defaults_lists_validate');
	register_setting('sendmsg_ap_opts', 'sendmsg_woocommerce_ap_id_transform_matrix_raw');
	register_setting('sendmsg_opts', 'sendmsg_transform', 'sendmsg_transform_validate');
}

add_action('admin_menu', 'sendmsg_opts_add_page');
function sendmsg_opts_add_page()
{

	add_menu_page('הגדרות תוסף שלח מרסר', 'שלח מסר', 'manage_options', 'sendmsg_opts', 'sendmsg_opts_do_page', SENDMSG_PLUGIN_DIR . 'assets/images/icons/color-16x16.png');

	if (getConsumer() != null) {
		add_submenu_page('sendmsg_opts', 'הגדרות תוסף שלח מסר - ווקומרס', 'ווקומרס', 'manage_options', 'sendmsg_opts_woocommerce', 'sendmsg_opts_woocommerce_do_page');
		add_submenu_page('sendmsg_opts', 'הגדרות תוסף שלח מסר - תוכנית שותפים', 'תוכנית שותפים', 'manage_options', 'sendmsg_opts_ap', 'sendmsg_opts_ap_do_page');
	}
}


function sendmsg_opts_woocommerce_do_page()
{
	if (isset($_GET['settings-updated'])) { ?>
		<div id="message" class="updated">
			<p><strong><?php _e('Settings saved.') ?></strong></p>
		</div>
	<?php } ?>
	<div class="wrap">
		<h2>הגדרות תוסף שלח מסר - ווקומרס</h2>

		<div style="direction: rtl;">כאן תוכלו להגדיר הגדרות כלליות שקשורות להעברת מידע בין החנות שלכם לבין שלח מסר, כגון
			הוספה לרשימה או הסרה מרשימה, וכן הצלבת שדות ומידע.<br /> כאשר מתבצעת רכישה באתר המידע הזה יועבר לשלח מסר ותוכלו
			להמשיך לדוור ללקוחות שלכם מידע כללי על האתר שלכם. <br /><br /> במידה ואתם רוצים להתאים ללקוח שלכם מידע לפי המוצר
			שרכש,<br /> תוכלו להתאים לו את הרשימה בתוך המוצר עצמו. <br /><br /> יש לכם לשונית חדשה שנוצרה בעת התקנת התוסף
			בתוך הגדרות המוצר. <br />בלשונית תמצאו התאמה של רשימה ספציפית בעת רכישת מוצר, כך שהלקוח יכנס לרשימה המתאימה לפי
			המוצר שרכש.<br /> בנוסף תוכלו להתאים שדות ספציפים כך שהמידע שנכנס בעת הרכישה יעבור גם לשלח מסר. <br /><br />כאשר
			לקוח חדש רוכש משהו בחנות באתר (דרך תוסף:woocommerce ) הוסף אותו תמיד לרשימה הזאת בשלח מסר:
		</div>
		<form method="post" action="options.php">
			<?php

			$options = get_option('sendmsg_woocommerce_opts');
			settings_fields('sendmsg_woocommerce_opts');
			render_lists_and_transform_admin('woocommerce');

			?>
			<p class="submit">
				<input type="submit" class="button-primary" value="<?php echo _e('Save Changes'); ?>" />
			</p>
			*ניתן להשאיר ריק ולהתאים את הרשימה לפי המוצר שנרכש
		</form>
	</div>
	<?php /* ?> debug: <textarea><?php var_dump(get_option('wc_debug_last_order_data')) ?></textarea> <?php */ ?>
	<?php
	add_new_list_Script();
}
function sendmsg_opts_ap_do_page()
{
	if (isset($_GET['settings-updated'])) { ?>
		<div id="message" class="updated">
			<p><strong><?php _e('Settings saved.') ?></strong></p>
		</div>
	<?php } ?>
	<div class="wrap">
		<div style="direction: rtl;">
			<h2>הוראות שימוש בתוכנית השותפים</h2>
			<p>תוסף הwp-affiliate platform מאפשר לכם להכניס תוכנית שותפים לאתר הוורדפרס שלכם ולהגדיל את המכירות
				שלכם.<br />כאן תוכלו לחבר את התוסף אל מערכת <strong>שלח מסר</strong>, כדי שתדעו מאיפה הגיעה כל מכירה,
				ולאיזה שותף אפשר לתת את העמלה.<br /> <b>להורדת התוסף לחץ <a target="_blank" href="https://www.tipsandtricks-hq.com/?ap_id=comstar">כאן!</a></b></p>

		</div>
		<form method="post" action="options.php">
			<?php settings_fields('sendmsg_ap_opts'); ?>
			<?php $options = get_option('sendmsg_ap_opts'); ?>
			<h2>הוספת ליד חדש לקבוצת דיוור בצירוף קוד שותף</h2>
			<?php render_lists_and_transform_admin('user_register_ap_id'); ?>
			<h2>הוספת מתשתמש שביצע רכישה לקבוצת דיוור בצירוף קוד שותף</h2>
			<?php render_lists_and_transform_admin('woocommerce_ap_id'); ?>
			<p class="submit">
				<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
			</p>
		</form>
	</div>
<?php

	add_new_list_Script();
}

function sendmsg_api_opts_validate($input)
{
	return $input;
}
function sendmsg_woocommerce_opts_validate($input)
{
	return $input;
}
function sendmsg_ap_opts_validate($input)
{
	return $input;
}
function sendmsg_woocommerce_defaults_lists_validate($input)
{
	return $input;
}
function sendmsg_woocommerce_transform_validate($input)
{
	return $input;
}
function sendmsg_transform_validate($input)
{
	return $input;
}
function sendmsg_user_register_defaults_lists_validate($input)
{
	return $input;
}


function add_new_list_Script()
{
	$jsCode = "<script id='SMplugin' type='text/javascript'>
		jQuery('.create_new_list_button').click(function($) {
			alert('אנא המתן מספר שניות ליצירת רשימה חדשה');
			jQuery('.creating_list_label#' + $.target.id).css('visibility', 'visible');
			var list_name = jQuery('.create_new_list_textfield#' + $.target.id).val();
			var data = {
				'action': 'create_new_list',
				'list_name': list_name
			};

			// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
			debugger;
			jQuery.post(ajaxurl, data, function(response) {
				jQuery.post(ajaxurl, {
					'action': 'get_lists'
				}, function(lists) {
					var updatedList = jQuery();
					lists.forEach(function(l) {
						updatedList = updatedList.add('<option value=' + l.id + '>' + l.name + '</option>');
					});
					jQuery('select.groups-list').empty().append(updatedList);
					jQuery('select.groups-list#' + $.target.id + ' option:contains(' + list_name + ')').prop('selected', true);
					jQuery('.creating_list_label#' + $.target.id).css('visibility', 'hidden');
				});
			});
		});

		var list = [" . select_keys_reduce() . "];

		var __$ = jQuery;

		function remove(array, element) {
			index = array.indexOf(element);
			if (index != -1) array.splice(index, 1);
		}
		Array.prototype.clone = function() {
			return this.slice(0);
		};

	</script>  ";
	echo $jsCode;
}

function select_keys_reduce()
{
	$output = "";

	foreach (get_option('sendmsg_fields_keys') as $key_name) {
		$output .= '"' . $key_name . '", ';
	}

	return $output;
}

?>